unsigned int pfm_csum(const unsigned char *src, int len, unsigned int sum)
{
	int count;
	__asm__ __volatile__ (
		"	"PREFETCH" (%0)\n"
		"	"PREFETCH" 64(%0)\n"
		"	"PREFETCH" 128(%0)\n"
		"	"PREFETCH" 192(%0)\n"
			: : "r" (src)
	);

	count = len/(8*8);
	while(count--)
 {
		__asm__ __volatile__ (
		"1:	"PREFETCH" 256(%1)\n"
		"	xorl	%%ecx, %%ecx\n"	//carry unset - we need it
		"	mov	$8, %%cl\n"
		"2:	adcl	(%1), %%eax\n"
		"	adcl	4(%1), %%eax\n"
		"	leal	8(%1), %1\n"
		"	loop	2b\n"
		"	adcl	$0, %%eax\n"
			: /* output */	"=a" (sum)
			: /* input */	"r" (src), "a" (sum)
			: /* clobber */	"cx", "memory"
		);
	}
	return sum;
}
